当前位置:   article > 正文

【LeetCode】 215. 数组中的第K个最大元素 大顶堆_数组中的第k个最大元素大顶堆

数组中的第k个最大元素大顶堆

题目

题目传送门:传送门(点击此处)
在这里插入图片描述

题解

思路

这道题目是有难度的,如果使用先排序的方法,就有一点墨迹了,所以我们这道题目借助堆的数据结构,实现最大堆就可以了

代码

class Solution {
    public int findKthLargest(int[] nums, int k) {
        // init heap 'the smallest element first'
        PriorityQueue<Integer> heap = new PriorityQueue<Integer>((n1, n2) -> n1 - n2);
        // keep k largest elements in the heap
        for (int n : nums) {
            heap.add(n);
            if (heap.size() > k)
                heap.poll();
        }
        // output
        return heap.poll();
    }
}
  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12
  • 13
  • 14
声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/你好赵伟/article/detail/206267
推荐阅读
相关标签
  

闽ICP备14008679号